
_Set_up:

;keypad.c,38 :: 		void Set_up() {
;keypad.c,40 :: 		ANSEL = 0;      // Pin RA2 sets as analog input.
	CLRF       ANSEL+0
;keypad.c,41 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;keypad.c,42 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;keypad.c,43 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;keypad.c,44 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;keypad.c,45 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;keypad.c,46 :: 		TRISD1_bit=0;
	BCF        TRISD1_bit+0, BitPos(TRISD1_bit+0)
;keypad.c,47 :: 		TRISB = 0x0F;
	MOVLW      15
	MOVWF      TRISB+0
;keypad.c,48 :: 		Led = 0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;keypad.c,49 :: 		PORTB = 0x0F;
	MOVLW      15
	MOVWF      PORTB+0
;keypad.c,50 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;keypad.c,51 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;keypad.c,52 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;keypad.c,53 :: 		Lcd_Out(1, 6, "KEY");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      6
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_keypad+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;keypad.c,54 :: 		}
L_end_Set_up:
	RETURN
; end of _Set_up

_blink:

;keypad.c,55 :: 		void blink() {
;keypad.c,58 :: 		Led=1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;keypad.c,59 :: 		Delay_ms(80);
	MOVLW      208
	MOVWF      R12+0
	MOVLW      201
	MOVWF      R13+0
L_blink0:
	DECFSZ     R13+0, 1
	GOTO       L_blink0
	DECFSZ     R12+0, 1
	GOTO       L_blink0
	NOP
	NOP
;keypad.c,60 :: 		Led=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;keypad.c,61 :: 		Delay_ms(80);
	MOVLW      208
	MOVWF      R12+0
	MOVLW      201
	MOVWF      R13+0
L_blink1:
	DECFSZ     R13+0, 1
	GOTO       L_blink1
	DECFSZ     R12+0, 1
	GOTO       L_blink1
	NOP
	NOP
;keypad.c,62 :: 		}
L_end_blink:
	RETURN
; end of _blink

_main:

;keypad.c,64 :: 		void main() {
;keypad.c,66 :: 		Set_up();
	CALL       _Set_up+0
;keypad.c,68 :: 		while (1)  {
L_main2:
;keypad.c,70 :: 		for(i=0;i<4;i++){
	CLRF       _i+0
L_main4:
	MOVLW      128
	XORWF      _i+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      4
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main5
;keypad.c,72 :: 		Row1=1;
	BSF        RB7_bit+0, BitPos(RB7_bit+0)
;keypad.c,73 :: 		Row2=0;
	BCF        RB6_bit+0, BitPos(RB6_bit+0)
;keypad.c,74 :: 		Row3=0;
	BCF        RB5_bit+0, BitPos(RB5_bit+0)
;keypad.c,75 :: 		Row4=0;
	BCF        RB4_bit+0, BitPos(RB4_bit+0)
;keypad.c,76 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main7:
	DECFSZ     R13+0, 1
	GOTO       L_main7
	DECFSZ     R12+0, 1
	GOTO       L_main7
	NOP
	NOP
;keypad.c,78 :: 		if((Col1==1)&& (i==0) ) tecla='+', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 3
	GOTO       L_main10
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main10
L__main75:
	MOVLW      43
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      43
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main10:
;keypad.c,79 :: 		if((Col2==1)&& (i==0) ) tecla='-', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 2
	GOTO       L_main13
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main13
L__main74:
	MOVLW      45
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      45
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main13:
;keypad.c,80 :: 		if((Col3==1)&& (i==0) ) tecla='x', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 1
	GOTO       L_main16
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main16
L__main73:
	MOVLW      120
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      120
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main16:
;keypad.c,81 :: 		if((Col4==1)&& (i==0) ) tecla='%', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 0
	GOTO       L_main19
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main19
L__main72:
	MOVLW      37
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      37
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main19:
;keypad.c,83 :: 		Row1=0;
	BCF        RB7_bit+0, BitPos(RB7_bit+0)
;keypad.c,84 :: 		Row2=1;
	BSF        RB6_bit+0, BitPos(RB6_bit+0)
;keypad.c,85 :: 		Row3=0;
	BCF        RB5_bit+0, BitPos(RB5_bit+0)
;keypad.c,86 :: 		Row4=0;
	BCF        RB4_bit+0, BitPos(RB4_bit+0)
;keypad.c,87 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main20:
	DECFSZ     R13+0, 1
	GOTO       L_main20
	DECFSZ     R12+0, 1
	GOTO       L_main20
	NOP
	NOP
;keypad.c,89 :: 		if((Col1==1)&& (i==1) ) tecla='=', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 3
	GOTO       L_main23
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main23
L__main71:
	MOVLW      61
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      61
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main23:
;keypad.c,90 :: 		if((Col2==1)&& (i==1) ) tecla='3', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 2
	GOTO       L_main26
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main26
L__main70:
	MOVLW      51
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      51
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main26:
;keypad.c,91 :: 		if((Col3==1)&& (i==1) ) tecla='6', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 1
	GOTO       L_main29
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main29
L__main69:
	MOVLW      54
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      54
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main29:
;keypad.c,92 :: 		if((Col4==1)&& (i==1) ) tecla='9', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 0
	GOTO       L_main32
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main32
L__main68:
	MOVLW      57
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      57
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main32:
;keypad.c,94 :: 		Row1=0;
	BCF        RB7_bit+0, BitPos(RB7_bit+0)
;keypad.c,95 :: 		Row2=0;
	BCF        RB6_bit+0, BitPos(RB6_bit+0)
;keypad.c,96 :: 		Row3=1;
	BSF        RB5_bit+0, BitPos(RB5_bit+0)
;keypad.c,97 :: 		Row4=0;
	BCF        RB4_bit+0, BitPos(RB4_bit+0)
;keypad.c,98 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main33:
	DECFSZ     R13+0, 1
	GOTO       L_main33
	DECFSZ     R12+0, 1
	GOTO       L_main33
	NOP
	NOP
;keypad.c,100 :: 		if((Col1==1)&& (i==2) ) tecla='0', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 3
	GOTO       L_main36
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main36
L__main67:
	MOVLW      48
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main36:
;keypad.c,101 :: 		if((Col2==1)&& (i==2) ) tecla='2', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 2
	GOTO       L_main39
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main39
L__main66:
	MOVLW      50
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      50
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main39:
;keypad.c,102 :: 		if((Col3==1)&& (i==2) ) tecla='5', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 1
	GOTO       L_main42
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main42
L__main65:
	MOVLW      53
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      53
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main42:
;keypad.c,103 :: 		if((Col4==1)&& (i==2) ) tecla='8', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 0
	GOTO       L_main45
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main45
L__main64:
	MOVLW      56
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      56
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main45:
;keypad.c,105 :: 		Row1=0;
	BCF        RB7_bit+0, BitPos(RB7_bit+0)
;keypad.c,106 :: 		Row2=0;
	BCF        RB6_bit+0, BitPos(RB6_bit+0)
;keypad.c,107 :: 		Row3=0;
	BCF        RB5_bit+0, BitPos(RB5_bit+0)
;keypad.c,108 :: 		Row4=1;
	BSF        RB4_bit+0, BitPos(RB4_bit+0)
;keypad.c,109 :: 		Delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main46:
	DECFSZ     R13+0, 1
	GOTO       L_main46
	DECFSZ     R12+0, 1
	GOTO       L_main46
	NOP
	NOP
;keypad.c,111 :: 		if((Col1==1)&& (i==3) ) tecla='*', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 3
	GOTO       L_main49
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main49
L__main63:
	MOVLW      42
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      42
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main49:
;keypad.c,112 :: 		if((Col2==1)&& (i==3) ) tecla='1', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 2
	GOTO       L_main52
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main52
L__main62:
	MOVLW      49
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      49
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main52:
;keypad.c,113 :: 		if((Col3==1)&& (i==3) ) tecla='4', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 1
	GOTO       L_main55
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main55
L__main61:
	MOVLW      52
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      52
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main55:
;keypad.c,114 :: 		if((Col4==1)&& (i==3) ) tecla='7', Lcd_Chr(2,aux,tecla),blink(),aux++;
	BTFSS      PORTB+0, 0
	GOTO       L_main58
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main58
L__main60:
	MOVLW      55
	MOVWF      _tecla+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVF       _aux+0, 0
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      55
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	CALL       _blink+0
	INCF       _aux+0, 1
L_main58:
;keypad.c,70 :: 		for(i=0;i<4;i++){
	INCF       _i+0, 1
;keypad.c,116 :: 		}
	GOTO       L_main4
L_main5:
;keypad.c,118 :: 		if(aux>16) aux=1;
	MOVLW      128
	XORLW      16
	MOVWF      R0+0
	MOVLW      128
	XORWF      _aux+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main59
	MOVLW      1
	MOVWF      _aux+0
L_main59:
;keypad.c,119 :: 		}
	GOTO       L_main2
;keypad.c,120 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
