
//******************************************************************************
//*  key pad 4x4 without library                                              **
//*  external clk 8Mhz                                                        **
//******************************************************************************

#define  Led   RD1_bit

#define  Row1  RB7_bit
#define  Row2  RB6_bit
#define  Row3  RB5_bit
#define  Row4  RB4_bit

#define  Col1   PORTB.B3
#define  Col2   PORTB.B2
#define  Col3   PORTB.B1
#define  Col4   PORTB.B0

//////////////LCD_declarations///////////////

sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
//////////////////////////////////////////////

char tecla;
short int aux=1, i=0;
//////////////////////////////////////////////
void Set_up() {

  ANSEL = 0;      // Pin RA2 sets as analog input.
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  TRISD1_bit=0;
  TRISB = 0x0F;
  Led = 0;
  PORTB = 0x0F;
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  Lcd_Out(1, 6, "KEY");
}
void blink() {

  // put you code here
     Led=1;
     Delay_ms(80);
     Led=0;
     Delay_ms(80);
 }

void main() {

  Set_up();

 while (1)  {

        for(i=0;i<4;i++){

        Row1=1;
        Row2=0;
        Row3=0;
        Row4=0;
        Delay_ms(5);

        if((Col1==1)&& (i==0) ) tecla='+', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col2==1)&& (i==0) ) tecla='-', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col3==1)&& (i==0) ) tecla='x', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col4==1)&& (i==0) ) tecla='%', Lcd_Chr(2,aux,tecla),blink(),aux++;
        
        Row1=0;
        Row2=1;
        Row3=0;
        Row4=0;
        Delay_ms(5);

        if((Col1==1)&& (i==1) ) tecla='=', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col2==1)&& (i==1) ) tecla='3', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col3==1)&& (i==1) ) tecla='6', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col4==1)&& (i==1) ) tecla='9', Lcd_Chr(2,aux,tecla),blink(),aux++;
        
        Row1=0;
        Row2=0;
        Row3=1;
        Row4=0;
        Delay_ms(5);

        if((Col1==1)&& (i==2) ) tecla='0', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col2==1)&& (i==2) ) tecla='2', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col3==1)&& (i==2) ) tecla='5', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col4==1)&& (i==2) ) tecla='8', Lcd_Chr(2,aux,tecla),blink(),aux++;
        
        Row1=0;
        Row2=0;
        Row3=0;
        Row4=1;
        Delay_ms(5);

        if((Col1==1)&& (i==3) ) tecla='*', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col2==1)&& (i==3) ) tecla='1', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col3==1)&& (i==3) ) tecla='4', Lcd_Chr(2,aux,tecla),blink(),aux++;
        if((Col4==1)&& (i==3) ) tecla='7', Lcd_Chr(2,aux,tecla),blink(),aux++;

    }

        if(aux>16) aux=1;
 }
}